.486
.model flat, stdcall
option casemap :none
include \masm32\include\windows.inc
include \masm32\include\masm32.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc

include \masm32\macros\macros.asm
includelib \masm32\lib\masm32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib

_dwtoa proto :DWORD,:DWORD

printv MACRO varname:VARARG
    FOR arg,<varname>
        invoke StdOut,reparg(arg)
    ENDM
ENDM

; Set to 1 for all values in range.
STEP = 1234567
.data
    buffer1     db 14 dup(0)
    buffer2     db 14 dup(0)
    testValue   dd 7fffffffh
    testValue2   dd -1
    errorCount  dd 0
    testCount   dd 0
.code
start:

    ; Added memfill because bad values left trash in buffer.
    invoke _dwtoa,0,addr buffer1    
    printv SADD("0 = "),addr buffer1,SADD(13,10)
    invoke memfill,addr buffer1,14,0
    
    invoke _dwtoa,1,addr buffer1    
    printv SADD("1 = "),addr buffer1,SADD(13,10)
    invoke memfill,addr buffer1,14,0
    
    invoke _dwtoa,-1,addr buffer1    
    printv SADD("-1 = "),addr buffer1,SADD(13,10)
    invoke memfill,addr buffer1,14,0

    invoke _dwtoa,-1000000000,addr buffer1    
    printv SADD("-1000000000 = "),addr buffer1,SADD(13,10)
    invoke memfill,addr buffer1,14,0

    invoke _dwtoa,-2000000000,addr buffer1    
    printv SADD("-2000000000 = "),addr buffer1,SADD(13,10)
    invoke memfill,addr buffer1,14,0
    
    invoke _dwtoa,2147483647,addr buffer1    
    printv SADD("2147483647 = "),addr buffer1,SADD(13,10)
    invoke memfill,addr buffer1,14,0
    
    invoke _dwtoa,-2147483648,addr buffer1    
    printv SADD("-2147483648 = "),addr buffer1,SADD(13,10)
    invoke memfill,addr buffer1,14,0

    printv SADD("Press any key to test positive values")
    call getc
    ;exit

; This loop tests the range of positive values.
runLoop:
    inc testCount
    invoke _dwtoa,testValue,addr buffer1
    invoke dw2a,testValue,addr buffer2
    invoke lnstr,addr buffer1
    push eax
    invoke lnstr,addr buffer2
    pop edx
    cmp eax,edx
    je  @F   
    inc errorCount
    jmp doLoop
@@:    
    invoke cmpsi,addr buffer1,addr buffer2,edx
    or  eax,eax
    jz  doLoop
    inc errorCount
doLoop:
    sub testValue,STEP
    
    invoke _dwtoa,testValue,addr buffer1
    printv addr buffer1,SADD(13,10)

    mov eax,testValue
    invoke dw2a,eax,addr buffer2
    printv addr buffer2,SADD(13,10,13,10)

    cmp testValue,0
    jle @F    
    jmp runLoop
@@:
    invoke dw2a,errorCount,addr buffer2
    printv SADD("error count = "),addr buffer2,SADD(13,10)
    invoke dw2a,testCount,addr buffer2
    printv SADD("test count = "),addr buffer2,SADD(13,10)
    ;exit

    printv SADD("Press any key to test negative values")
    call getc
    
; This loop tests the range of negative values
runLoop2:
    inc testCount
    invoke _dwtoa,testValue2,addr buffer1
    mov eax,testValue2
    neg eax
    invoke dw2a,eax,addr buffer2    
    invoke lnstr,addr buffer1+1
    push eax
    invoke lnstr,addr buffer2
    pop edx
    cmp eax,edx
    je  @F
    inc errorCount
    jmp doLoop2
@@:
    invoke cmpsi,addr buffer1+1,addr buffer2,edx
    or  eax,eax
    jz  doLoop2
    inc errorCount
    
doLoop2:
    sub testValue2,STEP
    
    invoke _dwtoa,testValue2,addr buffer1
    printv addr buffer1+1,SADD(13,10)
    
    mov eax,testValue2
    neg eax
    invoke dw2a,eax,addr buffer2
    printv addr buffer2,SADD(13,10,13,10)
    
    cmp testValue2,0
    jg  @F
    jmp runLoop2
@@:
    invoke dw2a,errorCount,addr buffer2
    printv SADD("error count = "),addr buffer2,SADD(13,10)
    invoke dw2a,testCount,addr buffer2
    printv SADD("test count = "),addr buffer2,SADD(13,10)

    printv SADD("Press any key to exit")
    call getc
    exit

; #########################################################################

_dwtoa proc dwValue:DWORD, lpBuffer:DWORD    
    
    k = 42950                   ; 2^32 / 100000 rounded
    k2 = 429497                 ; 2^32 / 10000 rounded

    ;k = 42949                   ; 2^32 / 100000 truncated
    ;k2 = 429496                 ; 2^32 / 10000 truncated

    push ebx                    ; (1)
    push esi                    ; (1)
    push edi                    ; (1)
    mov eax,dwValue             ; (1)
    mov edi,lpBuffer            ; (1)

    or  eax,eax                 ; (1)
    jnz @F                      ; (1)
    ; Store "0" and terminator.
    mov word ptr[edi],30h       ; (1)
    pop edi                     ; (1)
    pop esi                     ; (1)
    pop ebx                     ; (1)
    ret                         ; (2)
@@:
    jns @F                      ; (1)
    mov byte ptr[edi],'-'       ; (1)
    neg eax                     ; (1)
    inc edi                     ; (1)
@@:
    ; ESI and EDI are reversed relative to the sample. 
    mov ebx,10
    ; Get (2^32 / 100000).
    mov ecx,k
    ; Div by 100000.
    mul ecx
    ; Save top 5 digits.
    mov esi,edx

    mov eax,100000 
    mul edx

    ; Get the number.
    sub eax,dwValue
    ; Get the low 5 digits. 
    neg eax

    ; About to divide 5 digit number by 10000.
    mov ecx,k2
    mul ecx
    
    ; First digit is now in DL, convert to ASCII and store.
    add edx,30h
    mov [edi+5],dl
    
    ; Multiply remainder by 10 to get next digit.
    mul ebx
    add edx,30h
    mov [edi+6],dl
    
    mul ebx
    add edx,30h
    mov [edi+7],dl
    
    mul ebx
    add edx,30h
    mov [edi+8],dl
    
    mul ebx
    add edx,30h
    mov [edi+9],dl
    
    ; First 5 digits done, now get next 5 and do the same.
    mov eax,esi
    
    mul ecx
    add edx,30h
    mov [edi+0],dl
    
    mul ebx
    add edx,30h
    mov [edi+1],dl
    
    mul ebx
    add edx,30h
    mov [edi+2],dl
    
    mul ebx
    add edx,30h
    mov [edi+3],dl
    
    mul ebx
    add edx,30h
    mov [edi+4],dl

    mov dword ptr[edi+10],0
    
    pop edi                     ; (1)
    pop esi                     ; (1)
    pop ebx                     ; (1)
    ret                         ; (2)
_dwtoa endp

; #########################################################################

getc proc
    ; Waits for and reads a single character from stdin (no echo).
    
    LOCAL hInput :DWORD
    LOCAL char   :DWORD
    LOCAL bRead  :DWORD

    invoke GetStdHandle,STD_INPUT_HANDLE
    mov hInput,eax

    invoke FlushConsoleInputBuffer,hInput

    invoke SetConsoleMode,hInput,ENABLE_PROCESSED_INPUT

    invoke ReadConsole,hInput,ADDR char,1,ADDR bRead,NULL

    invoke SetConsoleMode,hInput,ENABLE_LINE_INPUT or \
                                 ENABLE_ECHO_INPUT or \
                                 ENABLE_PROCESSED_INPUT
    mov eax,char
    
    ret
getc endp

; #########################################################################
    
end start
